From e51a1c8c57cc03331abbe7082754e64c6c656856 Mon Sep 17 00:00:00 2001
From: Akash Mehrotra <mehrotra.akash@gmail.com>
Date: Sun, 5 Jun 2011 02:18:52 +0530
Subject: [PATCH 2/2] Allows http interface to set the playback rate.
 Playback rate must be > 0

---
 share/lua/http/dialogs/main        |   11 +++++++++++
 share/lua/http/js/functions.js     |   16 ++++++++++++++++
 share/lua/http/requests/README.txt |    3 +++
 share/lua/http/requests/status.xml |    5 +++++
 4 files changed, 35 insertions(+), 0 deletions(-)

diff --git a/share/lua/http/dialogs/main b/share/lua/http/dialogs/main
index 5a6e837..119b686 100644
--- a/share/lua/http/dialogs/main
+++ b/share/lua/http/dialogs/main
@@ -109,6 +109,17 @@ sout and playlist .
       <span class="btn_text">Increase Audio Delay</span>
     </button>
     <span id="a_del">(?)</span> ms
+ <br />
+    Playback Speed:
+    <button id="btn_delay_down" onclick="playrate_down();" onmouseover="button_over(this);" onmouseout="button_out(this);" title="Decrease playback rate by 0.05x" >
+      <img src="images/minus.png" alt="Decrease Playback Rate" />
+      <span class="btn_text">Decrease Playback Rate</span>
+    </button>
+    <button id="btn_delay_up" onclick="playrate_up();" onmouseover="button_over(this);" onmouseout="button_out(this);" title="Increase playback rate by 0.05x" >
+      <img src="images/plus.png" alt="Increase Playback Rate" />
+      <span class="btn_text">Increase Playback Rate</span>
+    </button>
+    <span id="p_speed">(?)</span>x
 
   </div>
   <div id="status">
diff --git a/share/lua/http/js/functions.js b/share/lua/http/js/functions.js
index 42ca9b2..9ed7bf3 100644
--- a/share/lua/http/js/functions.js
+++ b/share/lua/http/js/functions.js
@@ -430,6 +430,20 @@ function audiodelay_up()
     curdelnew=curdelnew.toFixed(2);
     loadXMLDoc( 'requests/status.xml?command=audiodelay&val='+encodeURIComponent(curdelnew), parse_status );
 }
+function playrate_down()
+{
+    var currate = parseFloat(req.responseXML.documentElement.getElementsByTagName( 'playspeed' )[0].firstChild.data);
+    var curratenew = currate - 0.05;
+    curratenew=curratenew.toFixed(2);
+    loadXMLDoc( 'requests/status.xml?command=setrate&val='+encodeURIComponent(curratenew), parse_status );
+}
+function playrate_up()
+{
+    var currate = parseFloat(req.responseXML.documentElement.getElementsByTagName( 'playspeed' )[0].firstChild.data);
+    var curratenew = currate + 0.05;
+    curratenew=curratenew.toFixed(2);
+    loadXMLDoc( 'requests/status.xml?command=setrate&val='+encodeURIComponent(curratenew), parse_status );
+}
 
 /**********************************************************************
  * Parse xml replies to XMLHttpRequests
@@ -483,6 +497,8 @@ function parse_status()
             set_text( 'length', format_time( length ) );
             var audio_delay = (parseFloat(req.responseXML.documentElement.getElementsByTagName( 'audiodelay' )[0].firstChild.data).toFixed(2))*1000;
             set_text( 'a_del', audio_delay ); 
+            var play_speed = (parseFloat(req.responseXML.documentElement.getElementsByTagName( 'playspeed' )[0].firstChild.data).toFixed(2));
+            set_text( 'p_speed', play_speed ); 
             if( status.getElementsByTagName( 'volume' ).length != 0 )
                 set_text( 'volume', Math.floor(status.getElementsByTagName( 'volume' )[0].firstChild.data/5.12)+'%' );
             var statetag = status.getElementsByTagName( 'state' );
diff --git a/share/lua/http/requests/README.txt b/share/lua/http/requests/README.txt
index a0eabd8..8d0d523 100644
--- a/share/lua/http/requests/README.txt
+++ b/share/lua/http/requests/README.txt
@@ -53,6 +53,9 @@ status.xml:
 > set audio delay
   ?command=audiodelay&val=<delayinseconds>
 
+> set playback rate. must be > 0
+  ?command=setrate&val=<newplaybackrate>
+
 > sort playlist using sort mode <val> and order <id>:
   ?command=pl_sort&id=<id>&val=<val>
   If id=0 then items will be sorted in normal order, if id=1 they will be
diff --git a/share/lua/http/requests/status.xml b/share/lua/http/requests/status.xml
index dbad4e5..775aefa 100644
--- a/share/lua/http/requests/status.xml
+++ b/share/lua/http/requests/status.xml
@@ -115,6 +115,10 @@ elseif command == "audiodelay" then
   if vlc.object.input() and val then
    vlc.var.set(vlc.object.input(),"audio-delay",val)
   end
+elseif command == "setrate" then
+  if vlc.object.input() and tonumber(val) >= 0 then
+   vlc.var.set(vlc.object.input(),"rate",val)
+  end
 end
 
 local input = nil
@@ -130,6 +134,7 @@ local vout = input and vlc.object.find(input,'vout','child')
 <root>
   <volume><?vlc print(vlc.volume.get()) ?></volume>
   <audiodelay><?vlc if input then print(vlc.var.get(input,"audio-delay")) else print (0) end ?></audiodelay>
+  <playspeed><?vlc if input then print(vlc.var.get(input,"rate")) else print (1) end ?></playspeed>
   <length><?vlc if input then print(math.floor(vlc.var.get(input,"length"))) else print(0) end?></length>
   <time><?vlc if input then print(math.floor(vlc.var.get(input,"time"))) else print(0) end?></time>
   <state><?vlc print(vlc.playlist.status()) ?></state>
-- 
1.7.4.1

